/*
*	Hampau Raluca Maria 335 CB
*	5x7 Matrix Memory Game
*	Proiect PM 2018
*/
#include <avr/io.h>

#define F_CPU 16000000

#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>


/*butoane pentru control*/
unsigned char up = PD0;
unsigned char left = PD1;
unsigned char down = PD2;
unsigned char right = PD3;
unsigned char select = PD4;

/* pini led-uri */					 
unsigned char col[5] = {PB0, PB1, PB2, PB3, PB4};			 
unsigned char lin[7] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6}; 



void draw(int c[], int l[], int n){

	int i, j;
	for(i = 0; i < 50; i++){
		for(j = 0; j < n; j++){
			PORTB |= (1 << col[c[j]]);
			PORTA &= ~(1 << lin[l[j]]);
			_delay_ms(1);
			PORTB = 0x00;
			PORTA = 0xFF;
		}
	}	
}

void draw_one(){

	int c[9] = {0,1,2,2,2,2,2,2,2};
	int l[9] = {2,1,0,1,2,3,4,5,6};
	draw(c, l, 9);
}
void draw_two(){

	int c[13] = {0,1,2,3,4,3,2,1,0,1,2,3,4};
	int l[13] = {2,1,0,1,2,3,4,5,6,6,6,6,6};
	draw(c, l, 13);
}
void draw_three(){

	int c[11] = {0,1,2,3,4,3,4,3,2,1,0};
	int l[11] = {2,1,0,1,2,3,4,5,6,5,4};
	draw(c, l, 11);
}

void demo(){
	
	draw_one();
	_delay_ms(200);
	draw_two();
	_delay_ms(200);
	draw_three();
	_delay_ms(200);
	
}

void init(){
	
	DDRA = 0xFF;
	DDRB = 0xFF;

	PORTA = 0x00;
	PORTB = 0xFF;

	DDRD = 0x00;
	PORTD = 0xFF;
	
}

int main(){

	int posx = 0, posy = 0;
	int c[1], l[1];
	
	
	init();
	while(1){
		
		demo();
		
		/*
		l[0] = posx;
		c[0] = posy;
		draw(c,l,1);
		
		if((PIND & (1 << up)) == 0){
			posy = (posy + 1) % 5;
			_delay_ms(200);
		}
		
		else if((PIND & (1 << down)) == 0){
			posy = ((posy - 1) >= 0) ? posy - 1 : 4;
			_delay_ms(200);
		}
		
		else if((PIND & (1 << left)) == 0){
			posx = ((posx - 1) >= 0) ? posx - 1 : 6;
			_delay_ms(200);
		}
		
		else if((PIND & (1 << right)) == 0){
			posx = (posx + 1) % 7;
			_delay_ms(200);
		}
		*/
		
	}
	
	return 0;
}